\SXPROG.XPL	MAR-21-98	Version 1.0
\Scenix SX Programmer using the SX-Key
\Copyright (C) 1998 Loren Blaney
\
\This software is based on a preliminary version (0.3) of Parallax's SX-Key.
\ It might not work with a later version. In fact it could damage your equipment.
\ It comes with ABSOLUTELY NO WARRANTY. The entire risk is assumed by the user.
\ This software is not certified or authorized by either Parallax or Scenix.
\
\This program is free software; you can redistribute it and/or modify it under
\ the terms of the GNU General Public License version 2 as published by the
\ Free Software Foundation.
\This program is distributed in the hope that it will be useful, but WITHOUT
\ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
\ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
\ details.
\You should have received a copy of the GNU General Public License along with
\ this program (in the file LICENSE.DOC); if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\You can reach me at:			Mail:	Loren Blaney
\ Email: loren_blaney@idcomm.com		502 Pine Glade Dr.
\						Nederland, CO 80466, USA
\
\This program was compiled with the version 2.3 XPL0 compiler (XPLX, 16-bit).
\ It is available from: http://www.brouhaha.com/~eric/computers/xpl0/
\ I can send you a copy of this compiler if you can't find it.
\
\REVISIONS:
\1.0, MAR-21-98, Released.


inc	\CXPL\CODESI;	\Include code definitions for intrinsic routines

def	Debug = false;	\Enable debug code (turn this off in final version)

def	T2=3000;	\Time between sending bytes to SX-Key (microseconds)
def	ROMSizeMax = $1020; \Maximum size of instruction memory (12-bit words)
			\includes space for ID bytes at $1000 and fuses at $1010
int	AOK,		\Flag: true if verify found no errors
	ComPort,	\COM port (1, 2, 3, or 4)
	Cpureg,		\Address of CPU register array (from Getreg)
	EraseTime,	\Amount of time for erase (milliseconds)
	II,		\Scratch for Main
	ProgTime,	\Amount of time for programming each word (milliseconds)
	ReadSwitch,	\Command line switch: read instead of program SX chip
	ReadROM(ROMSizeMax), \Code space read from SX chip
	FileROM(ROMSizeMax), \Code space read from .HEX file
	SenseAmp,	\Flag: Sense amp is on (rather than automatic)
	SerData,	\Serial (COM) port data register
	SerStat,	\Serial (COM) port status register
	VerifySwitch;	\Command line switch: verify instead of programming

def	TV=0, KB=0;						\I/O devices
def	Nul=$00, Bel=$07, BS=$08, Tab=$09, LF=$0A, FF=$0C,	\Control chars
	CR=$0D, EOF=$1A, Esc=$1B, Sp=$20, Ctrl=$40;
def	UpArrow=$48, DnArrow=$50, LtArrow=$4B, RtArrow=$4D,	\Key scan codes
	PageUp=$49, PageDn=$51, Home=$47, End=$4F;

\DOSOpen variables:
int	PSPSeg,		\Paragraph address of PSP segment (for file I/O)
	DataSeg;	\Paragraph address of data segment (heap & stack)

\===============================================================================

proc	ShowHelp;	\Show help message
begin
Text(TV, "
Usage:	SXPROG filename [.hex] [/R] [/V]
	/R: Read SX chip and display contents
	/V: Verify that SX chip = filename

");
end;	\ShowHelp



func	CallInt(Int, AX, BX, CX, DX, BP, DS, ES); \Call software interrupt
int	Int, AX, BX, CX, DX, BP, DS, ES; \(Unused arguments need not be passed)
begin
Cpureg:= Getreg;
Cpureg(0):= AX;
Cpureg(1):= BX;
Cpureg(2):= CX;
Cpureg(3):= DX;
Cpureg(6):= BP;
Cpureg(9):= DS;
Cpureg(11):= ES;
Softint(Int);
return Cpureg(0);		\Return AX register
end;	\CallInt



func	GetKey;		\Get character from keyboard (wait if necessary)
int	SC, Ch;			\This is a low-level routine with no echo,
begin				\ no Ctrl-C, and no cursor.
SC:= CallInt($16, $0000);	\Function $00
Ch:= SC & $FF;
if Ch = 0 then Ch:= -(SC>>8);	\Return non-ASCII chars as negative scan code
return Ch;
end;	\GetKey



proc	Hex1Out(Dev, N); \Output N as one ASCII hex digit
int	Dev, N;
char	HexDigit; 	\Array: ASCII hex digits (0 - F)
begin
HexDigit:= "0123456789ABCDEF ";
Chout(Dev, HexDigit(N & $0F));
end;	\Hex1Out



proc	Hex2Out(Dev, N); \Output byte N as two ASCII hex digits
int	Dev, N;
char	HexDigit; 	\Array: ASCII hex digits (0 - F)
begin
HexDigit:= "0123456789ABCDEF ";
Chout(Dev, HexDigit(N >>4 & $0F));
Chout(Dev, HexDigit(N & $0F));
end;	\Hex2Out



proc	Hex3Out(Dev, N); \Output N as three ASCII hex digits
int	Dev, N;
begin
Hex1Out(Dev, N >>8);
Hex2Out(Dev, N);
end;	\Hex3Out



proc	Delay(T);	\Delay T microseconds
int	T;
begin
CallInt($15, $8600, 0, 0, T);
end;	\Delay

\===============================================================================

proc	Timeout;	\Fatal timeout error--display message and abort program
begin
Text(TV, "
Timeout on COM");   Intout(TV, ComPort);   Crlf(TV);
exit 1;
end;	\Timeout



proc	SerOpen(Comm, Baud);	\Initialize communications port
int	Comm,		\Comm port number (1, 2, 3, or 4)
	Baud;		\Baud rate (unsigned)
int	N, Base;
begin
Comm:= (Comm-1)*2;
Base:= Peek($40, Comm) + Swap(Peek($40, Comm+1));

SerData:= Base;
SerStat:= Base+5;

Pout($80, Base+3, 0);		\Set up baud rate generator
N:= 1152 / (Baud>>1/50);	\First divide unsigned baud rate by 100
Pout(Swap(N), Base+1, 0);
Pout(N, Base, 0);

\   BITS:	765		43		2		10
\		NOT USED	PARITY		STOP BITS	WORD LENGTH
\		XXX		X0 = none	0 = 1 bit	10 = 7 bits
\				01 = odd	1 = 2 bits	11 = 8 bits
\				11 = even
Pout($03, Base+3, 0);		\No parity, 1 stop, 8 bits

Pout($00, Base+1, 0);		\No interrupts
Pout($03, Base+4, 0);		\Turn on RTS and DTR

N:= Pin(Base, 0);		\"Kick some life into it"
N:= Pin(Base, 0);
end;	\SerOpen



proc	SerOut(Ch);	\Send a character out the serial port
int	Ch;
begin
repeat until (Pin(SerStat,0) & $20) \#0\;	\Transmitter holding reg empty
Pout(Ch, SerData, 0);
end;	\SerOut



func	SerIn;	\Receive a character from serial port and allow Ctrl+C and
int	F;					\ timeouts to abort program
begin
CallInt($15, $8301);	\Cancel any previous timing request
F:= 0;
\Set bit 7 of flag F 2 seconds (= $1E8480 microseconds) from now
CallInt($15, $8300, addr F, $1E, $8480, 0, 0, DataSeg);
loop	begin
	if (Pin(SerStat,0) & $01) \#0\ then quit;	\Data ready
	if Chkkey then
		if GetKey = ^C-Ctrl then exit 1;
	if F \#0\ then Timeout;
	end;
return Pin(SerData, 0);		\Read in data and return it
end;	\SerIn



proc	SendCh(Ch);	\Send ASCII string to SX-Key
char	Ch;
begin
Delay(T2);
Serout(Ch);
Ch:= SerIn;		\Read in echo and discard it
end;	\SendCh



proc	SendStr(Str);	\Send ASCII string to SX-Key
char	Str;
int	I, Ch;
begin
I:= 0;
loop	begin
	Ch:= Str(I);
	I:= I + 1;
	if Ch >= $80 then quit;
	SendCh(Ch);
	end;
SendCh(Ch & $7F);
end;	\SendStr



proc	SendPreamble;	\Send command preamble
int	I;
char	Str;
begin
SendStr("^@SX-Key");	\Send preamble
Str:= "SX-Key ";	\Beware of MSB on last character in string
for I:= 0, 5 do		\SX-Key must echo back SX-Key, otherwise abort
	begin
	if Str(I) # SerIn then
		begin
		Crlf(TV);
		Text(TV, "Error: Expected ^"SX-Key^" preamble not echoed back
");
		exit 1;
		end;
	end;
end;	\SendPreamble



proc	SerInNul;	\Read in nul (00) character; abort program if not nul
int	Ch;
begin
Ch:= SerIn;
if Ch # $00 then
	begin
	Crlf(TV);	\Error: $xx received instead of $00
	Text(TV, "Error: $");
	Hex2Out(TV, Ch);
	Text(TV, " received instead of $00
");
	SendCh(0);
	exit 1;
	end;
end;	\SerInNul

\=============================== DOS FILE I/O =================================

proc	DOSOpen;	\Routine to open MS-DOS files
int	Inx,		\Index into CmdTail
	InHand,		\Input file handle
	Switch;		\Switch character from command line
def	FileNameSize=40; \Maximum number of characters in a file name
char	InFileName(FileNameSize), \Input file name
	CmdTail(80);	\Command tail, including length byte at beginning



func	GetSwitch;	\Find, remove and return switch character
int	I, Ch;
begin
for I:= 1, CmdTail(0) do		\For all characters in the command tail
	begin
	if CmdTail(I) = ^/ then
		begin
		CmdTail(I):= Sp;	\Overwrite switch with space character
		if I < CmdTail(0) then	\ (so Fopen doesn't see it)
			begin
			Ch:= CmdTail(I+1);
			if Ch>=^a & Ch<=^z then Ch:= Ch-$20; \Make uppercase
			CmdTail(I+1):= Sp;
			return Ch;	\Overwrite switch character too
			end;		\ (so Fopen doesn't see it)
		end;
	end;
return Nul;		\Return Nul if no switch found
end;	\GetSwitch



proc	CopyName(From, To, Ext);
\Copy file name from "From" to "To" and append extension if it's not typed in
char	From, To,	\Strings are terminated by 0 & must be <= FileNameSize
	Ext;		\Extension started with "." and terminated with an
			\ unused char with MSB set
int	I, J, Ch, HaveExt;
begin
I:= 0;
HaveExt:= false;
loop	begin
	Ch:= From(I);
	if Ch = 0 then quit;
	if Ch = ^. then HaveExt:= true;
	To(I):= Ch;
	if I < FileNameSize-1 then I:= I +1;
	end;
if ~HaveExt then
	begin
	for J:= 0, 3 do		\Append extension
		begin
		To(I):= Ext(J);
		if I < FileNameSize-1 then I:= I +1;
		end;
	To(I):= 0;
	end;
end;	\CopyName



proc	GetName(Name);	\Copy file name (and path) into Name array
\Inputs: Name, Inx, CmdTail, FileNameSize
char	Name;
int	I, Ch;
begin
while CmdTail(Inx) = Sp do Inx:= Inx +1;	\Skip spaces
I:= 0;
repeat	Ch:= CmdTail(Inx);
	Inx:= Inx +1;
	if Ch=Sp ! Ch=CR then Ch:= 0;		\Terminate Name with 0
	Name(I):= Ch;
	if I < FileNameSize-1 then I:= I +1;
until Ch = 0;
end;	\GetName



begin	\DOSOpen
Blit(PSPSeg, $80, DataSeg, CmdTail, 79);	\Get copy of command tail
if CmdTail(0)>79 then CmdTail(0):= 79;		\Limit length byte

\Handle switches
ReadSwitch:= false;
VerifySwitch:= false;
loop	begin
	Switch:= GetSwitch;
	case Switch of
	  ^R:	ReadSwitch:= true;
	  ^V:	VerifySwitch:= true;
	  Nul:	quit			\No more switches on command line
	other	begin
		Text(TV, "Unrecognized switch: /");
		Chout(TV, Switch);
		Crlf(TV);
		ShowHelp;
		exit 1;			\Abort program
		end;
	end;

if ReadSwitch & ~VerifySwitch then return;	\No input file necessary

Inx:= 1;	\Start index after length byte at start of CmdTail
GetName(InFileName);
if InFileName(0) = 0 then		\Fatal error if no file specified
	begin
	Text(0, "No input hex file specified
");
	ShowHelp;
	exit 1;				\Abort program
	end;

CopyName(InFileName, InFileName, ".HEX ");	\Append .HEX if necessary
Trap(false);
InHand:= Fopen(InFileName, 0);			\Open InFileName for input
if Geterr \#0\ then 
	begin
	Text(0, "Hex file not found
");
	ShowHelp;
	exit 1;				\Abort program
	end;
Trap(Debug);				\Turn traps on if not debug

Fset(InHand, ^I);			\Finish opening InFileName for input
Openi(3);
end;	\DOSOpen

\-------------------------------------------------------------------------------

proc	GetConfig;	\Get configuration variables from disk file
int	Hand;
\Outputs: ComPort, EraseTime, ProgTime, SenseAmp
begin
Trap(false);
Hand:= Fopen("SXPROG.CFG", 0);		\Get input handle
if Geterr \#0\ then	\If file not found then use default values
	begin		\ (i.e. don't throw a fit with an I/O ERROR)
	ComPort:= 1;
	EraseTime:= 1000;
	ProgTime:= 100;
	SenseAmp:= false;
	end
else	begin
	Fset(Hand, ^I);
	Openi(3);
	ComPort:= Intin(3);
	EraseTime:= Intin(3);
	ProgTime:= Intin(3);
	SenseAmp:= Intin(3);
	FClose(Hand);
	end;
Trap(Debug);
end;	\GetConfig

\===============================================================================

proc	Fatal(Str);	\Display error message and abort program
char	Str;
begin
Text(TV, "Error: ");
Text(TV, Str);
Crlf(TV);
ShowHelp;
exit 1;
end;	\Fatal

\-------------------------------------------------------------------------------

func	HexByte;	\Read in 2 chars and return the value of the hex byte
int	Ch, Hex;	\ (Optimized for speed)
begin
loop	begin
	Ch:= Chin(3);
	if Ch <= ^9 then
		if Ch >= ^0 then [Hex:= (Ch-^0)<<4;   quit];
	if CH >= ^A then
		if Ch <= ^F then [Hex:= (Ch-$37)<<4;   quit];
	Fatal("Hex character expected");
	end;

Ch:= Chin(3);
if Ch <= ^9 then
	if Ch >= ^0 then return Hex + Ch - ^0;
if Ch >= ^A then
	if Ch <= ^F then return Hex + Ch - $37;
Fatal("Hex character expected");
end;	\HexByte



proc	LoadHexFile;	\Load an Intel hex format file (.HEX from MPASM)
\Inputs: ROM
int	I,
	RecLen,		\Record length
	Addr,
	Type,		\Record type: 00 for data, 01 for end-of-file
	Cksum,
	N,
	Data;
char	Mem;		\Facilitates loading bytes into ROM array
begin
\Record Format:
\:BBAAAATTHHHH...HHHHCC
\BB = Number of data bytes (HH) in record
\AAAA = Address to load into, high byte first
\TT = Record type: 00 for data, 01 for end-of-file
\HH = Data, low byte, high byte
\CC = Checksum, two's complement of the sum of all preceding bytes in the record

for I:= 0, ROMSizeMax-1 do FileROM(I):= $FFFF;

Text(TV, "Loading hex file...
");
Mem:= FileROM;
Openi(3);
loop	begin
	repeat N:= Chin(3) until N =^:;

	RecLen:= HexByte;
	Cksum:= RecLen;

	Addr:= HexByte;
	Cksum:= Cksum + Addr;
	Addr:= Swap(Addr) ! HexByte;
	Cksum:= Cksum + Addr;

	Type:= HexByte;
	Cksum:= Cksum + Type;

	for N:= 1, RecLen do
		begin
		Data:= HexByte;
		if Addr >= ROMSizeMax*2 then	\(ROMSizeMax in bytes)
			Fatal("File too big");
		Mem(Addr):= Data;
		Cksum:= Cksum + Data;
		Addr:= Addr + 1;
		end;
	Cksum:= Cksum + HexByte;
	if (Cksum & $FF) # $00 then Fatal("Checksum");
	if Type = $01 then quit;
	end;
end;	\LoadHexFile

\===============================================================================

proc	ShowFuses;	\Show fuse configuration info stored in ROM array
int	FUSE, FUSEX, I, Ch, T;
\
\	ID:     xxxxxxxx	[X] Turbo Mode
\				[X] Stack Extend
\	Pins:   28		[X] OPTION Extend
\	ROM:  1024 words	[ ] ADD/SUB with C
\	RAM:   137 bytes	[ ] Input Syncing
\	Osc:   500 kHz		[ ] Watchdog Timer
\	Reset: 4.0 volts	[ ] Code Protect
\		
begin
FUSE:= FileROM($1010) & $0FFF;	\(Mask for safety)
FUSEX:= FileROM($1011) & $0FFF;

Text(TV, "ID:     ");
for I:= $1000, $1010-1 do
	begin
	Ch:= FileROM(I)<<4 ! (FileROM(I+1) & $000F);
	if Ch<$20 ! Ch>$7E then Ch:= Sp;
	Chout(TV, Ch);
	I:= I + 1;
	end;
Text(TV, "	[");
Chout(TV, if FUSE & $800 then Sp else ^X);
Text(TV, "] Turbo Mode
");
Text(TV, "			[");
Chout(TV, if FUSE & $100 then Sp else ^X);
Text(TV, "] Stack Extend
");
Text(TV, "Pins:   ");
T:= [18, 28, 40, 64];
Intout(TV, T(FUSEX>>10));
Text(TV, "		[");
Chout(TV, if FUSE & $200 then Sp else ^X);
Text(TV, "] OPTION Extend
");
Text(TV, "ROM:  ");
T:= [" 512", "1024", "2048", "4096"];
Text(TV, T(FUSEX & $003));
Text(TV, " words	[");
Chout(TV, if FUSEX & $040 then Sp else ^X);
Text(TV, "] ADD/SUB with C
");
Text(TV, "RAM:   ");
T:= $10 << (FUSEX>>2 & $003) + 8;
if (FUSEX & $C00) = 0 \18 pins\ then T:= T + 1;
if T < 100 then Chout(TV, Sp);
Intout(TV, T);
Text(TV, " bytes	[");
Chout(TV, if FUSE & $400 then Sp else ^X);
Text(TV, "] Input Syncing
");
Text(TV, "Osc:   ");
if FUSE & $080 then	\IRC_ disabled--use FOSC1:FOSC2
	begin
	T:= [" LP", " XT", " HS", " RC"];
	Text(TV, T(FUSE & $003));
	end
else	begin		\Internal osc enabled
	T:= [ "4.0 MHz", "2.0 MHz", "1.0 MHz", "500 kHz",
	      "250 kHz", "125 kHz", " 62 kHz", " 31 kHz"];
	Text(TV, T(FUSE>>4 & $007));
	end;
Text(TV, "		[");
Chout(TV, if FUSE & $004 then ^X else Sp);
Text(TV, "] Watchdog Timer
");
Text(TV, "Reset: ");
T:= [ "4.0 volts", "2.5 volts", "1.3 volts", "Off	"];	\(Actually 4.2V)
Text(TV, T(FUSEX>>4 & $003));
Text(TV, "	[");
Chout(TV, if FUSE & $008 then Sp else ^X);
Text(TV, "] Code Protect

");
end;	\ShowFuses



proc	ShowROM;	\Display the contents of the ROM array and fuses
int	L, J, Addr;					\ (never returns)
int	CursorShape;	\Shape of flashing cursor to be restored when exiting
begin
TrapC(true);			\Make sure flashing cursor is properly restored
CallInt($10, $0300);		\Save flashing cursor shape
CursorShape:= Cpureg(2);
CallInt($10, $0100, 0, $2000);	\Turn off flashing cursor
Chout(TV, FF);
ShowFuses;

Addr:= $0000;
L:= 0;
\0010:  000 000 000 000  000 000 000 000  000 000 000 000  000 000 000 000 
loop	begin
	Hexout(TV, Addr);
	Chout(TV, ^:);
	for J:= 0, $F do
		begin
		Chout(TV, Sp);
		if (J&3) = 0 then Chout(TV, Sp);
		Hex3Out(TV, FileROM(Addr));
		Addr:= Addr + 1;
		end;
	Crlf(TV);
	L:= L + 1;
	if L >= $10 then
		begin
		L:= 0;
		Text(TV,
"                                             (PgUp  PgDn  Home  End  Esc)");
		CallInt($10, $0100, 0, CursorShape);	\Restore flashing cursor
		case GetKey of
		  -PageUp,
		  -UpArrow: [Addr:= Addr - $200;  if Addr < 0 then Addr:= 0];
		  -Home:   Addr:= $000;
		  -End:    Addr:= $800 - $100;		\2K max
		  Esc, ^C-Ctrl: [Crlf(TV);   exit 0]
		other;
		if Addr >= \ROMSizeMax\$800 then Addr:= \ROMSizeMax\$800-$100;

		CallInt($10, $0300);		\Save flashing cursor shape
		CursorShape:= Cpureg(2);
		CallInt($10, $0100, 0, $2000);	\Turn off flashing cursor
		Cursor(0, 0);
		Chout(TV, CR);		\Make tabs stop in correct position
		ShowFuses;
		end;
	end;
end;	\ShowROM

\------------------------------------------------------------------------------

proc	ReadSX;		\Read SX chip into ReadROM array
int	I,
	DEVICE, FUSEX, FUSE,
	SizeROM,	\Amount of ROM to program (words)
	SizeA,		\Actual size bits
	SizeC,		\Configured size bits (from FUSEX)
	Mask;		\for bargraph
begin
for I:= 0, ROMSizeMax-1 do ReadROM(I):= $FFFF;

Text(TV, "Reading... ");
for I:= 0, 31 do Chout(TV, $B0);
Chout(TV, CR);
Text(TV, "Reading... ");

SendPreamble;
SendCh(2);
DEVICE:= SerIn ! SerIn<<8;

SendCh(2);
FUSEX:= SerIn ! SerIn<<8;
ReadROM($1011):= FUSEX;

SendCh(2);
FUSE:= SerIn ! SerIn<<8;
ReadROM($1010):= FUSE;

\Set SizeROM to the smaller of the configured size (from FUSEX) or the
\ actual size (from DEVICE) (an erased chip will look like it's 4096 words)
SizeA:= DEVICE & $003;
SizeC:= FUSEX & $003;
SizeROM:= SizeC;
if SizeA < SizeC then SizeROM:= SizeA;
Mask:= $10<<SizeROM - 1;
SizeROM:= $200 << SizeROM;

\Read program bytes
for I:= 0, SizeROM-1 do
	begin
	SendCh(2);		\Read back two bytes
	ReadROM(I):= SerIn ! SerIn<<8;
	if (I & Mask) = 0 then Chout(TV, $B2);
	end;

\Read ID bytes
for I:= $1000, $100F do
	begin
	SendCh(2);		\Read back two bytes
	ReadROM(I):= SerIn ! SerIn<<8;
	end;
Crlf(TV);
SendCh(0);
SerInNul;
end;	\ReadSX

\------------------------------------------------------------------------------

func	ConvertTime(T);	\Convert time to SX-Key format
int	T;	\Milliseconds
begin
T:= Fix(Float(T) * 1.375);
return ~T;
end;	\ConvertTime



proc	ROMSizeMessage(Size);	\Display ROM size message: "xxx words (x pages)"
int	Size;	\ROM size bits
begin
if Size = 0 then Chout(TV, Sp);
Intout(TV, $200<<Size);
Text(TV, " words (");
Intout(TV, 1<<Size);
Text(TV, " page");
if Size # 0 then Chout(TV, ^s);
Chout(TV, ^));
Crlf(TV);
end;	\ROMSizeMessage



proc	ProgSX;		\Program the SX chip with data in ROM array
int	I, Data;
int	DEVICE, FUSEX,
	SizeROM,	\Amount of ROM to program (words)
	SizeA,		\Actual size bits
	SizeC,		\Configured size bits (from FUSEX)
	Mask;		\for bargraph
begin
SendPreamble;
SendCh(2);
DEVICE:= SerIn ! SerIn<<8;

\FUSEX is presumably read to get the number of pins, but this makes no sense
\ because, although it's documented as a factory-preset value, it is in fact
\ settable, and thus unreliable. (i.e. a 28-pin device could be reprogrammed
\ to look like an 18-pin device.)
SendCh(2);
FUSEX:= SerIn ! SerIn<<8;

SendCh(0);
SerInNul;

\Set ROM size to the smaller of the configured size (from FUSEX) or the
\ actual size (from DEVICE)
SizeA:= DEVICE & $003;
FUSEX:= FileROM($1011);			\Get program's size bits
SizeC:= FUSEX & $003;
SizeROM:= SizeC;
if SizeA < SizeC then
	begin
	SizeROM:= SizeA;
	Text(TV, 
"Fuse configuration bits indicate program is larger than available memory.
");
	\Display: "Configured ROM size = xxx words (x pages)"
	Text(TV, "Configured ROM size = ");
	ROMSizeMessage(SizeC);

	\Display: "Actual ROM size =     xxx words (x pages)"
	Text(TV, "Actual ROM size =     ");
	ROMSizeMessage(SizeA);
	end;
Mask:= $10<<SizeROM - 1;
SizeROM:= $200 << SizeROM;

for I:= 1, 10 do Delay(25000);		\250 ms

\---------------

\Erasing (xxxx ms)...
Text(TV, "Erasing (");   Intout(TV, EraseTime);   Text(TV, " ms)... ");
SendPreamble;
Delay(30000);				\30 ms

I:= ConvertTime(EraseTime);
SendCh(1);
SendCh(I);
SendCh(I>>8);
SendCh($FF);
SendCh($FF);

SerInNul;
\(1 sec delay for erase)
SerInNul;
SendCh(0);
SerInNul;
Crlf(TV);
for I:= 1, 10 do Delay(25000);		\250 ms

\---------------

\Programming (xxx ms)...
Text(TV, "Programming (");   Intout(TV, ProgTime);   Text(TV, " ms)... ");
for I:= 0, 31 do Chout(TV, $B0);
Chout(TV, CR);
Text(TV, "Programming (");   Intout(TV, ProgTime);   Text(TV, " ms)... ");

SendPreamble;
Delay(10000);				\10 ms

I:= ConvertTime(ProgTime);
SendCh(1);
SendCh($FF);
SendCh($FF);
SendCh(I);
SendCh(I>>8);

SerInNul;
SerInNul;

Data:= FileROM($1011);			\Pack up FUSEX word
\If SenseAmp # 0 then enable it by clearing B_OSC bit
Data:= if SenseAmp then Data & $FF7F else Data ! $0080;
Data:= Data<<1 ! $8001;

SendCh(Data);
SendCh(Data>>8);
SerInNul;

Data:= FileROM($1010)<<1 ! $8001;	\Pack up FUSE word
SendCh(Data);
SendCh(Data>>8);
SerInNul;

for I:= 0, SizeROM-1 do			\Send data
	begin
	Data:= FileROM(I)<<1 ! $8001;	\Pack up data word
	SendCh(Data);
	SendCh(Data>>8);
	SerInNul;
	if (I & Mask) = 0 then Chout(TV, $B2);
	end;

for I:= $1000, $100F do			\Send ID bytes
	begin
	Data:= FileROM(I)<<1 ! $8001;	\Pack up data word
	SendCh(Data);
	SendCh(Data>>8);
	SerInNul;
	end;
SendCh(0);
SerInNul;
Crlf(TV);		\Beware of screen scrolls altering timing
end;	\ProgSX

\===============================================================================

begin	\Main
Cpureg:= Getreg;	\Set up for DOSOpen
PSPSeg:= Cpureg(11);
DataSeg:= Cpureg(12);

Chout(0, FF);		\Beware of screen scrolls altering timing
Text(TV, "Scenix SX Programmer, Version 1.0
 Copyright (C) 1998 Loren Blaney

This software is based on a preliminary version (0.3) of Parallax's SX-Key.
It might not work with a later version. In fact it could damage your equipment.
It comes with ABSOLUTELY NO WARRANTY. The entire risk is assumed by the user.
This software is not certified or authorized by either Parallax or Scenix.

This is free software. You are welcome and encouraged to redistribute it under
certain conditions. For details see LICENSE.DOC.

");

GetConfig;		\Get comm port, etc.
DOSOpen;		\Open file and/or get switches
			\(Leaves traps turned off if debug = false)
Text(TV, "Initializing COM");   Intout(TV, ComPort);   Text(TV, "...");
Crlf(TV);
SerOpen(ComPort, 19200);		\Set up COM Port for 19200 baud

if VerifySwitch then							\VERIFY
	begin
	LoadHexFile;
	Crlf(TV);
	ShowFuses;
	ReadSX;
	AOK:= true;
	for II:= 0, ROMSizeMax-1 do
		begin
		if II = $1011 then
			begin	\Deal with sense amp affecting bit 7 in FUSEX
			FileROM(II):= FileROM(II) ! $0080;
			ReadROM(II):= ReadROM(II) ! $0080;
			end;
		if (FileROM(II)&$0FFF) # (ReadROM(II)&$0FFF) then
			begin
			AOK:= false;
			\Location: xxxx   File: xxx   Chip: xxx
			Text(TV, "Location: ");   Hexout(TV, II);
			Text(TV, "   File: ");   Hex3out(TV, FileROM(II));
			Text(TV, "   Chip: ");   Hex3out(TV, ReadROM(II));
			Crlf(TV);
			end;
		end;
	if AOK then Text(TV, "No differences found
")	else exit 1;
	end
else if ReadSwitch then							\READ
	begin
	ReadSX;
	for II:= 0, ROMSizeMax-1 do FileROM(II):= ReadROM(II);
	ShowROM;
	end
else	begin								\PROGRAM
	LoadHexFile;
	Crlf(TV);
	ShowFuses;
	ProgSX;
	end;
exit 0;					\Exit with no errors
end;	\Main
